from celery import group
# from hips_worker import sleep
import hips_worker
import time

# r = sleep.delay(123)

from asyncio import sleep, create_task

import asyncio

async def cancel_task(task):
    task.cancel()
    try:
        await task
    except asyncio.CancelledError:
        pass


async def run_jobs(job, sleep_time=0.1):
    r= job.apply_async()

    while not r.ready():
        await sleep(sleep_time)



site = "celery@X260"
i = hips_worker.app.control.inspect([site])

async def tick():
    while True:

        print({(k, len(v)) for k, v in i.active().items()})
        print({(k, len(v)) for k, v in i.reserved().items()})

        await sleep(1)

async def main():
    task_tick = create_task(tick())

    job = group(hips_worker.sleep.s(i) for i in range(10))

    task_jobs = create_task(run_jobs(job, 0.1))

    await task_jobs

    await cancel_task(task_tick)

asyncio.run(main())

